module CRule where

import Data.List
import Term
import Rule

-- Conditional Rule
type CRule = ([Rule], Rule)

functions :: CRule -> [String]
functions (cs, (l, r))
 = nub (Term.functions l
     ++ Term.functions r
     ++ [ f | (s, t) <- cs, f <- union (Term.functions s) (Term.functions t)])

showCRule :: CRule -> String
showCRule (cs, (l, r)) =
  show l ++ " -> " ++ show r ++ " <== " ++
  intercalate " | " [ show s ++ " = " ++ show t | (s, t) <- cs ]

crule2rule :: CRule -> Rule
crule2rule = snd
