module CTRS where

import Data.List

import CRule
import TRS

type CTRS = [CRule]

functions :: CTRS -> [String]
functions ctrs =
  nub [ f | crule <- ctrs, f <- CRule.functions crule ]

signatureOf :: CTRS -> [(String, Int)]
signatureOf ctrs =
  TRS.signatureOf ([ rl | (_, rl) <- ctrs] ++ [ c | (cs, _) <- ctrs, c <- cs])

ctrs2trs :: CTRS -> TRS
ctrs2trs ctrs = map crule2rule ctrs

showCTRS :: CTRS -> String
showCTRS trs = unlines [ "  " ++ showCRule rule | rule <- trs ]
