module INF where

import Data.List

import Term
import TRS
import CTRS

type Query = [(Term, Term)]

data INFProblem = SemiEquational (CTRS, Query) | Join (CTRS, Query) | Oriented (CTRS, Query)
-- the second argument of the tuple is CONDITION (existential closure of the conjunction of conditions)

-- TODO: avoid name collision
tupling :: Query -> (Term, Term)
tupling [q] = q
tupling qs = (F "__tp" (map fst qs), F "__tp" (map snd qs))

signatureOf' :: (CTRS, Query) -> [(String, Int)] 
signatureOf' (ctrs, qs) = union (CTRS.signatureOf ctrs) (TRS.signatureOf qs)

signatureOf :: INFProblem -> [(String, Int)] 
signatureOf (SemiEquational (ctrs, qs)) = signatureOf' (ctrs, qs)
signatureOf (Join (ctrs, qs)) = signatureOf' (ctrs, qs)
signatureOf (Oriented (ctrs, qs)) = signatureOf' (ctrs, qs)
