module Status where

import Data.List

import Term

-- status
-- only filtering, no permutation
type Status = [(String, [Bool])]

args :: Status -> Term -> [Term]
args _ (V _) = []
args st (F f ts) =
  case lookup f st of
    Nothing -> error ("function symbol " ++ f ++ " is not found in status")
    Just bs -> [ t | (b, t) <- zip bs ts, b ]

showStatus' :: (String, [Bool]) -> String
showStatus' (f, bs) =
  f ++ ": " ++ show [ i | (i :: Int, b) <- zip [1..] bs, b ]

showStatus :: Status -> String
showStatus st =
  "status:\n" ++ 
  intercalate "\n" [ showStatus' r | r <- st ]
